package dev.shadowsoffire.apotheosis.potion;

import java.util.HashSet;
import net.minecraft.core.registries.BuiltInRegistries;
import java.util.Iterator;
import net.minecraft.world.level.ItemLike;
import net.minecraft.world.item.alchemy.Potion;
import net.minecraft.world.item.CreativeModeTab;
import net.minecraftforge.api.distmarker.Dist;
import net.minecraftforge.api.distmarker.OnlyIn;
import net.minecraft.network.chat.MutableComponent;
import net.minecraft.world.effect.MobEffectUtil;
import net.minecraft.ChatFormatting;
import net.minecraft.world.item.TooltipFlag;
import net.minecraft.network.chat.Component;
import java.util.List;
import net.minecraft.world.item.enchantment.Enchantment;
import net.minecraft.sounds.SoundSource;
import net.minecraft.sounds.SoundEvents;
import net.minecraft.world.InteractionResultHolder;
import net.minecraft.world.InteractionHand;
import net.minecraft.world.entity.player.Player;
import net.minecraftforge.registries.ForgeRegistries;
import net.minecraft.world.effect.MobEffect;
import net.minecraft.world.effect.MobEffectInstance;
import net.minecraft.world.effect.MobEffects;
import net.minecraft.server.level.ServerPlayer;
import net.minecraft.world.entity.Entity;
import net.minecraft.world.level.Level;
import net.minecraft.world.item.alchemy.PotionUtils;
import net.minecraft.world.item.alchemy.Potions;
import net.minecraft.world.item.ItemStack;
import net.minecraft.resources.ResourceLocation;
import java.util.Set;
import dev.shadowsoffire.placebo.tabs.ITabFiller;
import net.minecraft.world.item.Item;

public class PotionCharmItem extends Item implements ITabFiller
{
    public static final Set<ResourceLocation> EXTENDED_POTIONS;
    public static final Set<ResourceLocation> BLACKLIST;
    
    public PotionCharmItem() {
        super(new Item.Properties().m_41487_(1).m_41503_(192).setNoRepair());
    }
    
    public ItemStack m_7968_() {
        return PotionUtils.m_43549_(super.m_7968_(), Potions.f_43606_);
    }
    
    public void m_6883_(final ItemStack stack, final Level world, final Entity entity, final int slot, final boolean isSelected) {
        if (!hasEffect(stack)) {
            return;
        }
        if (PotionModule.charmsInCuriosOnly && slot != -1) {
            return;
        }
        if (stack.m_41784_().m_128471_("charm_enabled") && entity instanceof ServerPlayer) {
            final MobEffectInstance contained = getEffect(stack);
            final MobEffectInstance active = ((ServerPlayer)entity).m_21124_(contained.m_19544_());
            if (active == null || active.m_19557_() < getCriticalDuration(active.m_19544_())) {
                int durationOffset = getCriticalDuration(contained.m_19544_());
                if (contained.m_19544_() == MobEffects.f_19605_) {
                    durationOffset += 50 >> contained.m_19564_();
                }
                final MobEffectInstance newEffect = new MobEffectInstance(contained.m_19544_(), (int)Math.ceil(contained.m_19557_() / 24.0) + durationOffset, contained.m_19564_(), false, false);
                ((ServerPlayer)entity).m_7292_(newEffect);
                if (stack.m_220157_((contained.m_19544_() == MobEffects.f_19605_) ? 2 : 1, world.f_46441_, (ServerPlayer)entity)) {
                    stack.m_41774_(1);
                }
            }
        }
    }
    
    private static int getCriticalDuration(final MobEffect effect) {
        return PotionCharmItem.EXTENDED_POTIONS.contains(ForgeRegistries.MOB_EFFECTS.getKey((Object)effect)) ? 210 : 5;
    }
    
    public boolean m_5812_(final ItemStack stack) {
        return stack.m_41784_().m_128471_("charm_enabled");
    }
    
    public InteractionResultHolder<ItemStack> m_7203_(final Level world, final Player player, final InteractionHand hand) {
        final ItemStack stack = player.m_21120_(hand);
        if (!world.f_46443_) {
            stack.m_41784_().m_128379_("charm_enabled", !stack.m_41783_().m_128471_("charm_enabled"));
        }
        else if (!stack.m_41783_().m_128471_("charm_enabled")) {
            world.m_5594_(player, player.m_20183_(), SoundEvents.f_11871_, SoundSource.PLAYERS, 1.0f, 0.3f);
        }
        return (InteractionResultHolder<ItemStack>)InteractionResultHolder.m_19090_((Object)stack);
    }
    
    public boolean m_8120_(final ItemStack stack) {
        return false;
    }
    
    public boolean canApplyAtEnchantingTable(final ItemStack stack, final Enchantment enchantment) {
        return false;
    }
    
    @OnlyIn(Dist.CLIENT)
    public void m_7373_(final ItemStack stack, final Level world, final List<Component> tooltip, final TooltipFlag flag) {
        if (PotionModule.charmsInCuriosOnly) {
            tooltip.add((Component)Component.m_237115_(this.m_5524_() + ".curios_only").m_130940_(ChatFormatting.RED));
        }
        if (hasEffect(stack)) {
            final MobEffectInstance effect = getEffect(stack);
            MutableComponent potionCmp = Component.m_237115_(effect.m_19576_());
            if (effect.m_19564_() > 0) {
                potionCmp = Component.m_237110_("potion.withAmplifier", new Object[] { potionCmp, Component.m_237115_("potion.potency." + effect.m_19564_()) });
            }
            potionCmp.m_130940_(effect.m_19544_().m_19483_().m_19497_());
            tooltip.add((Component)Component.m_237110_(this.m_5524_() + ".desc", new Object[] { potionCmp }).m_130940_(ChatFormatting.GRAY));
            final boolean enabled = stack.m_41784_().m_128471_("charm_enabled");
            final MutableComponent enabledCmp = Component.m_237115_(this.m_5524_() + (enabled ? ".enabled" : ".disabled"));
            enabledCmp.m_130940_(enabled ? ChatFormatting.BLUE : ChatFormatting.RED);
            if (effect.m_19557_() > 20) {
                potionCmp = Component.m_237110_("potion.withDuration", new Object[] { potionCmp, MobEffectUtil.m_267641_(effect, 1.0f) });
            }
            potionCmp.m_130940_(effect.m_19544_().m_19483_().m_19497_());
            tooltip.add((Component)Component.m_237110_(this.m_5524_() + ".desc3", new Object[] { potionCmp }).m_130940_(ChatFormatting.GRAY));
        }
    }
    
    public int getMaxDamage(final ItemStack stack) {
        if (!hasEffect(stack)) {
            return 1;
        }
        return 192;
    }
    
    public Component m_7626_(final ItemStack stack) {
        if (!hasEffect(stack)) {
            return (Component)Component.m_237115_("item.apotheosis.potion_charm_broke");
        }
        final MobEffectInstance effect = getEffect(stack);
        MutableComponent potionCmp = Component.m_237115_(effect.m_19576_());
        if (effect.m_19564_() > 0) {
            potionCmp = Component.m_237110_("potion.withAmplifier", new Object[] { potionCmp, Component.m_237115_("potion.potency." + effect.m_19564_()) });
        }
        return (Component)Component.m_237110_("item.apotheosis.potion_charm", new Object[] { potionCmp });
    }
    
    public static boolean hasEffect(final ItemStack stack) {
        final List<MobEffectInstance> effects = PotionUtils.m_43547_(stack);
        return !effects.isEmpty();
    }
    
    public static MobEffectInstance getEffect(final ItemStack stack) {
        return PotionUtils.m_43547_(stack).get(0);
    }
    
    public void fillItemCategory(final CreativeModeTab group, final CreativeModeTab.Output out) {
        for (final Potion potion : ForgeRegistries.POTIONS) {
            if (isValidPotion(potion)) {
                out.m_246342_(PotionUtils.m_43549_(new ItemStack((ItemLike)this), potion));
            }
        }
    }
    
    public String getCreatorModId(final ItemStack itemStack) {
        final Potion potionType = PotionUtils.m_43579_(itemStack);
        final ResourceLocation resourceLocation = ForgeRegistries.POTIONS.getKey((Object)potionType);
        if (resourceLocation != null) {
            return resourceLocation.m_135827_();
        }
        return ForgeRegistries.ITEMS.getKey((Object)this).m_135827_();
    }
    
    public int m_6473_() {
        return 0;
    }
    
    public static boolean isValidPotion(final Potion potion) {
        if (potion.m_43488_().size() != 1) {
            return false;
        }
        final MobEffect effect = potion.m_43488_().get(0).m_19544_();
        return !effect.m_8093_() && !PotionCharmItem.BLACKLIST.contains(BuiltInRegistries.f_256974_.m_7981_((Object)effect));
    }
    
    static {
        EXTENDED_POTIONS = new HashSet<ResourceLocation>();
        BLACKLIST = new HashSet<ResourceLocation>();
    }
}
